#pragma once

#include <a8/singleton.h>
#include <f8/app.h>

class App : public f8::UserApp, public a8::Singleton<App>
{
private:
    App() {};
    friend class a8::Singleton<App>;

public:

    virtual const std::string GetPkgName() override;
    virtual void Init() override;
    virtual void UnInit() override;
    virtual void Update(int delta_time) override;
    virtual bool HasTask() override;
    virtual void DispatchSocketMsg(f8::MsgHdr* hdr) override;

    long long AllocTempHeroUniId();
    long long AllocTempWeaponUniId();
    bool IsServicing() const { return servicing_; }
    void SetServicing(bool open) { servicing_ = open; }
    int GetVersion();

public:
    int verify_set_pos = 0;

private:
    void ProcessGameGateMsg(f8::MsgHdr* hdr);

private:
    bool servicing_ = true;
    long long curr_uniid_ = 0;

    std::shared_ptr<int> version_;

};
