#include "precompile.h"

#include "btcoroutine.h"
#include "creature.h"
#include "trigger.h"
#include "base_agent.h"
#include "btcontext.h"
#include "btevent.h"
#include "perf.h"

BtCoroutine::BtCoroutine(std::shared_ptr<BtContext> context, int id, const char* name)
{
    context_ = context;
    id_ = id;
    name_ = name;
    INIT_LIST_HEAD(&entry);
    ++Perf::Instance()->bt_co_num;
}

BtCoroutine::~BtCoroutine()
{
    --Perf::Instance()->bt_co_num;
}

void BtCoroutine::Abort(long long frameno)
{
    is_abort_ = true;
    abort_frameno = frameno;
}
