#include "precompile.h"

#include "buff/add_inventory.h"

#include "creature.h"
#include "human.h"

#include "mt/Buff.h"

void AddInventoryBuff::Activate()
{
    for (int slot : meta->_buff_param2_int_list) {
        if (IsValidSlotId(slot)) {
            owner->buff_inventory_[slot].num += meta->_int_buff_param1;
        }
    }
    if (owner->IsHuman()) {
        owner->AsHuman()->RecalcVolume();
    }
    owner->MarkSyncActivePlayer(__FILE__, __LINE__, __func__);
}

void AddInventoryBuff::Deactivate()
{
    if (owner->IsHuman()) {
        for (int slot : meta->_buff_param2_int_list) {
            if (IsValidSlotId(slot)) {
                owner->AsHuman()->buff_inventory_[slot].num -= meta->_int_buff_param1;
                owner->AsHuman()->buff_inventory_[slot].num =
                    std::max(0, owner->AsHuman()->buff_inventory_[slot].num);
            }
        }
        owner->AsHuman()->RecalcVolume();
        owner->AsHuman()->MarkSyncActivePlayer(__FILE__, __LINE__, __func__);
    }
}
