#include "precompile.h"

#include "buff/camouflage_addition.h"

#include "creature.h"
#include "human.h"
#include "room.h"

#include "mt/Buff.h"

void CamouflageAdditionBuff::Activate()
{
    Buff* camouflage_buff = owner->GetBuffByEffectId(kBET_Camouflage);
    if (camouflage_buff && !camouflage_buff->remover_timer.expired() && meta->_int_buff_param1 > 0) {
        int remain_time = owner->room->xtimer.GetRemainTime(camouflage_buff->remover_timer) * FRAME_RATE_MS;
        remain_time += meta->_int_buff_param1;
        owner->room->xtimer.ModifyTime(camouflage_buff->remover_timer, remain_time / FRAME_RATE_MS);
    }
    if (meta->_int_buff_param2 != 0) {
        ++owner->camouflage_move_addition_;
    }
    if (meta->_int_buff_param3 != 0) {
        ++owner->camouflage_aiming_addition_;
    }
}

void CamouflageAdditionBuff::Deactivate()
{
    if (owner->AsHuman()) {
        if (meta->_int_buff_param2 != 0) {
            --owner->AsHuman()->camouflage_move_addition_;
        }
        if (meta->_int_buff_param3 != 0) {
            --owner->AsHuman()->camouflage_aiming_addition_;
        }
        owner->AsHuman()->camouflage_move_addition_ = std::max(owner->AsHuman()->camouflage_move_addition_, 0);
        owner->AsHuman()->camouflage_aiming_addition_ = std::max(owner->AsHuman()->camouflage_aiming_addition_, 0);
    }
}
