#include "precompile.h"

#include <f8/app.h>

#include "buff/modify_attr.h"

#include "creature.h"
#include "human.h"
#include "car.h"

#include "mt/Buff.h"
#include "mt/Skill.h"

void ModifyAttrBuff::Activate()
{
    int attr_id = meta->_int_buff_param1;
    float value = meta->GetBuffParam2(this);
    if (f8::App::Instance()->GetInstanceId() != 3) {
        attr_handle_ = owner->GetAbility()->AddAttr(attr_id, value);
#ifdef MYDEBUG
        if (!attr_handle_.expired()) {
            std::string source_name = a8::Format
                ("<-buff.%d.%d.%s",
                 {
                  meta->buff_id(),
                  skill_meta ? skill_meta->skill_id() : 0,
                  GetCaster().Get() ? (GetCaster().Get() == owner ? "self" : GetCaster().Get()->GetName() )
                  : "none"
                 });
            auto cb = std::make_shared<std::function<std::string()>>
                (
                 [source_name] () -> std::string
                 {
                     return source_name;
                 });
            owner->GetAbility()->SetSource(attr_handle_, cb);
        }
#endif
    }
}

void ModifyAttrBuff::Deactivate()
{
    if (!attr_handle_.expired()) {
        owner->GetAbility()->RemoveAttr(attr_handle_);
    }
}
