#include "precompile.h"

#include "buff/summon_loot.h"

#include "creature.h"
#include "room.h"
#include "loot.h"

#include "mt/Buff.h"
#include "mt/Equip.h"

void SummonLootBuff::Activate()
{
    if (!owner->dead || meta->dead_valid() != 0) {
        int equip_id = meta->_int_buff_param1;
        float x = meta->GetBuffParam2(this);
        float y = meta->GetBuffParam3(this);
        float z = meta->GetBuffParam4(this);
        int flag = meta->_int_buff_param5;
        float show_time = meta->GetBuffParam6(this);
        const mt::Equip* equip_meta = mt::Equip::GetById(equip_id);
        if (equip_meta) {
            int loot_uniid = owner->room->CreateLoot
                (
                 equip_id,
                 glm::vec3(x, y, z),
                 glm::vec3(x, y, z),
                 1,
                 1
                 );
            Entity* e = owner->room->GetEntityByUniId(loot_uniid);
            if (e && e->IsEntityType(ET_Loot)) {
                Loot* loot = (Loot*)e;
                loot->pickup_flag = flag;
                loot->buff_meta = meta;
                loot->skill_meta = skill_meta;
                loot->buff_vars = buff_vars;
                loot->master = owner->GetWeakPtrRef();

                owner->room->xtimer.SetTimeoutWpEx
                    (
                     show_time * SERVER_FRAME_RATE,
                     [loot] (int event, const a8::Args* args) mutable
                     {
                         if (a8::TIMER_EXEC_EVENT == event) {
                             loot->pickuped = true;
                             loot->room->RemoveObjectLater(loot);
                         }
                     },
                     &loot->xtimer_attacher);

            }
        }
    }
}

void SummonLootBuff::Deactivate()
{
}
