#pragma once

#include "cs_proto.pb.h"

struct FrameEventData
{
private:
    ::google::protobuf::RepeatedPtrField<::cs::MFAirDrop> airdrops_;
    ::google::protobuf::RepeatedPtrField<::cs::MFAirRaid> airraids_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFShot>> shots_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFBullet>> bullets_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFExplosion>> explosions_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFSmoke>> smokes_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFPlaySkill>> play_skills_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFEmote>> emotes_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFBuffChg>> chged_buffs_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFEffectChg>> chged_effects_;
    std::vector<std::tuple<CreatureWeakPtr, int, int>> chged_items_;
    std::vector<CreatureWeakPtr> chged_bullet_nums_;
    std::vector<std::tuple<CreatureWeakPtr, int, int, int>> chged_weapon_ammo_;
    std::vector<CreatureWeakPtr> chged_hps_;
    std::vector<std::tuple<CreatureWeakPtr, int, int>> chged_skillcds_;
    std::vector<std::tuple<CreatureWeakPtr, int, int>> chged_skill_curr_times_;
    std::vector<CreatureWeakPtr> chged_cars_;
    std::vector<std::tuple<int, int, int>> dead_alive_objs_;
    std::vector<std::tuple<CreatureWeakPtr, ::cs::MFPropertyChg>> chged_props_;
    std::vector<int> del_bullets_;
    std::vector<CreatureWeakPtr> enter_game_players_;
    std::vector<int> exit_game_players_;

    friend class FrameEvent;
    friend class FrameMaker;
    friend class SandTable;
};
