#pragma once

#include <a8/singleton.h>
#include <a8/basehttpsession.h>

#include <f8/types.h>
#include <f8/netmsghandler.h>

namespace a8
{
    class MutableXObject;
}

class HandlerMgr : public a8::Singleton<HandlerMgr>
{

 private:
    HandlerMgr() {};
    friend class a8::Singleton<HandlerMgr>;

 public:

    void Init();
    void UnInit();

    f8::NetMsgHandlerObject ggmsghandler;

    void RegisterGMMsgHandler(const std::string& msgname,
                              void (*)(std::shared_ptr<f8::JsonHttpRequest>));

 private:
    void RegisterNetMsgHandlers();
    void ProcGMMsg(unsigned long saddr, int sockhandle,
                   const std::string& url, const std::string& quyerstr);

    std::map<std::string, void (*)(std::shared_ptr<f8::JsonHttpRequest>)> gmhandlers_;
};
