#include "precompile.h"

#include "mt/AirLine.h"

IMPL_TABLE(mt::AirLine)
std::map<int, std::vector<const mt::AirLine*>> mt::AirLine::mapid_hash_;

namespace mt
{

    void AirLine::Init1()
    {
        {
            std::vector<std::string> strings;
            a8::Split(start_point(), strings, ':');
            start_point_.x = a8::XValue(strings[0]).GetDouble();
            start_point_.y = 0.0f;
            start_point_.z = a8::XValue(strings[1]).GetDouble();
        }
        {
            std::vector<std::string> strings;
            a8::Split(end_point(), strings, ':');
            end_point_.x = a8::XValue(strings[0]).GetDouble();
            end_point_.y = 0.0f;
            end_point_.z = a8::XValue(strings[1]).GetDouble();
        }
        {
            auto itr = mapid_hash_.find(map_id());
            if (itr != mapid_hash_.end()) {
                itr->second.push_back(this);
            } else {
                mapid_hash_[map_id()] = std::vector<const mt::AirLine*>({this});
            }
        }
    }

    const AirLine* AirLine::RandAirLine(int map_id)
    {
        auto itr = mapid_hash_.find(map_id);
        return itr != mapid_hash_.end() && !itr->second.empty() ?
            itr->second.at(rand() % itr->second.size()) : nullptr;
    }

}
