#pragma once

#include "mt/macro.h"
#include "mtb/AirLine.h"

namespace mt
{

    DECLARE_ID_TABLE(AirLine, mtb::AirLine,
                     "airline@airline.json",
                     "id")
    public:

        void Init1();
        const glm::vec3& GetStartPoint() const { return start_point_; };
        const glm::vec3& GetEndPoint() const { return end_point_; };

        static const AirLine* RandAirLine(int map_id);

    private:
        static std::map<int, std::vector<const mt::AirLine*>> mapid_hash_;

        glm::vec3 start_point_;
        glm::vec3 end_point_;
    };

}
