#include "precompile.h"

#include "mt/Drop.h"

IMPL_TABLE(mt::Drop)

namespace mt
{

    void Drop::Init1()
    {
        std::vector<std::string> item_list;
        {
            a8::Split(item_id(), item_list, '|');
        }
        std::vector<std::string> num_list;
        {
            a8::Split(num(), num_list, '|');
        }
        std::vector<std::string> weight_list;
        {
            a8::Split(weight(), weight_list, '|');
        }
        assert(item_list.size() == num_list.size() &&
               item_list.size() == weight_list.size());
        _total_weight = 0;
        for (size_t i = 0; i < item_list.size(); ++i) {
            _total_weight += a8::XValue(weight_list[i]).GetInt();
            std::vector<int> itemids;
            {
                std::vector<std::string> strings;
                a8::Split(item_list[i], strings, ':');
                for (auto& str : strings) {
                    itemids.push_back(a8::XValue(str).GetInt());
                }
            }
            std::vector<int> nums;
            {
                std::vector<std::string> strings;
                a8::Split(num_list[i], strings, ':');
                for (auto& str : strings) {
                    nums.push_back(a8::XValue(str).GetInt());
                }
            }
            assert(itemids.size() == nums.size());
            #if 1
            std::vector<int> item_lvs;
            for (size_t ii = 0; ii < itemids.size(); ++ii) {
                item_lvs.push_back(1);
            }
            #endif
            if (this->type() == 1) {
                auto item_tuple = std::make_tuple(
                                                  itemids,
                                                  nums,
                                                  item_lvs,
                                                  a8::XValue(weight_list[i]).GetInt()
                                                  );
                _items.push_back(item_tuple);
            } else {
                auto item_tuple = std::make_tuple(
                                                  itemids,
                                                  nums,
                                                  item_lvs,
                                                  _total_weight
                                                  );
                _items.push_back(item_tuple);
            }
        }
        assert(type() == 1 || type() == 2);
    }

    void Drop::RandItems(std::vector<std::tuple<int, int, int>>& drop_items) const
    {
        if (type() == 1) {
            for (auto& item : _items) {
                if ((rand() % 10000) <= std::get<3>(item)) {
                    for (size_t i = 0; i < std::get<0>(item).size(); ++i) {
                        drop_items.push_back(std::make_tuple(
                                                             std::get<0>(item)[i],
                                                             std::get<1>(item)[i],
                                                             std::get<2>(item)[i]
                                                             ));
                    }
                }
            }
        } else if (_total_weight > 0) {
            int rnd = rand() % (_total_weight + 1);
            for (auto& item : _items) {
                if (std::get<3>(item) >= rnd) {
                    for (size_t i = 0; i < std::get<0>(item).size(); ++i) {
                        drop_items.push_back(std::make_tuple(
                                                             std::get<0>(item)[i],
                                                             std::get<1>(item)[i],
                                                             std::get<2>(item)[i]
                                                             ));
                    }
                    break;
                }
            }
        }
    }
}
