#include "precompile.h"

#include "mt/Equip.h"
#include "mt/Buff.h"

IMPL_TABLE(mt::Equip)
std::map<int, const mt::Equip*> mt::Equip::slot_hash_;
const mt::Equip* mt::Equip::yellow_stone_ = nullptr;
const mt::Equip* mt::Equip::blue_stone_ = nullptr;
const mt::Equip* mt::Equip::purple_stone_ = nullptr;
const mt::Equip* mt::Equip::weapon_stone_ = nullptr;

namespace mt
{

    void Equip::Init1()
    {
        {
            shootfire_ = std::abs(shootfire());
            std::vector<std::string> strings;
            a8::Split(bullet_born_offset(), strings, '|');
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                assert(strings2.size() >= 2);
                _bullet_born_offset.push_back
                    (std::make_tuple(
                                     a8::XValue(strings2[0]).GetDouble(),
                                     a8::XValue(strings2[1]).GetDouble(),
                                     strings2.size() > 2 ? a8::XValue(strings2[2]).GetDouble() : 0,
                                     strings2.size() > 3 ? a8::XValue(strings2[3]).GetInt() : 0,
                                     strings2.size() > 4 ? a8::XValue(strings2[4]).GetInt() : 0,
                                     strings2.size() > 5 ? a8::XValue(strings2[5]).GetInt() : 0
                                     )
                     );
                if (std::get<5>(_bullet_born_offset[_bullet_born_offset.size() - 1]) != 0) {
                    lock_time = std::max(lock_time, strings2.size()>3 ? a8::XValue(strings2[3]).GetInt() : 0);
                }
#if 0
                if (strings2.size() > 4 && a8::XValue(strings2[4]).GetInt() == 1) {
                    lock_time = 0;
                }
#endif
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(atk(), strings, ':');
            if (strings.size() > 1) {
                _atk = a8::XValue(strings[0]).GetDouble();
                _atk_up = a8::XValue(strings[1]).GetDouble();
            } else {
                _atk = a8::XValue(atk()).GetDouble();
                _atk_up = _atk;
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(max_hp(), strings, ':');
            if (strings.size() > 1) {
                _max_hp = a8::XValue(strings[0]).GetDouble();
                _max_hp_up = a8::XValue(strings[1]).GetDouble();
            } else {
                _max_hp = a8::XValue(max_hp()).GetDouble();
                _max_hp_up = _max_hp;
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(volume(), strings, '|');
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                assert(strings2.size() == 2);
                if (strings2.size() >= 2) {
                    size_t slot = a8::XValue(strings2[0]);
                    size_t num = a8::XValue(strings2[1]);
                    if (slot >= 0 && slot < _volume.size()){
                        _volume[slot] = num;
                    }
                }
            }
        }
        {
            _int_param1 = a8::XValue(param1());
            _float_param1 = a8::XValue(param1()).GetDouble();
        }
        {
            _int_param2 = a8::XValue(param2());
            _float_param2 = a8::XValue(param2()).GetDouble();
        }
        {
            std::vector<std::string> strings;
            a8::Split(launch_dev(), strings, '|');
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                if (strings2.size() >= 2) {
                    _shoot_offsets.push_back(std::make_tuple
                                            (1,
                                             glm::vec3(
                                                      (float)a8::XValue(strings2[0]).GetDouble(),
                                                      0.0f,
                                                      (float)a8::XValue(strings2[1]).GetDouble())
                                             )
                                            );
                } else {
                    _shoot_offsets.push_back(std::make_tuple
                                            (0,
                                             glm::vec3(
                                                      0.0f,
                                                      0.0f,
                                                      0.0f
                                                      )
                                             ));
                }
            }
        }
        {
            std::vector<std::string> time_strings;
            a8::Split(power_time(), time_strings, '|');
            std::vector<std::string> gun_strings;
            a8::Split(power_gun(), gun_strings, '|');
            std::vector<std::string> buff_strings;
            a8::Split(power_buff(), buff_strings, '|');
            if (time_strings.size() == gun_strings.size() && gun_strings.size() == buff_strings.size()) {
                int last_time = -1;
                for (size_t i = 0; i < time_strings.size(); ++i) {
                    int time = a8::XValue(time_strings[i]);
                    int buff = a8::XValue(buff_strings[i]);
                    std::vector<std::string> tmp_strings;
                    a8::Split(gun_strings.at(i), tmp_strings, ':');
                    int gun = 0;
                    std::vector<int> times;
                    gun = a8::XValue(tmp_strings.at(0));
                    if (tmp_strings.size() == 1) {
                        times.push_back(0);
                    } else {
                        for (size_t ii = 1; ii < tmp_strings.size();  ++ii) {
                            times.push_back(a8::XValue(tmp_strings.at(ii)));
                        }
                    }
                    _power_charge.push_back(std::make_tuple(time, gun, buff, times));
                    if (time <= last_time && !IsMultistageGun()) {
                        A8_ABORT();
                    }
                    last_time = time;
                }
            } else {
                A8_ABORT();
            }
        }
        {
            if (buffid() != 0) {
                _buff_meta = mt::Buff::GetById(buffid());
                if (!_buff_meta) {
                    A8_ABORT();
                }
            }
        }
        if (equip_type() == EQUIP_TYPE_CAR) {
            std::vector<std::string> strings;
            a8::Split(param1(), strings, '|');
            int j = 0;
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                if (strings2.size() >= 2) {
                    switch (j) {
                    case 0:
                        {
                            _car_active_buff_id = a8::XValue(strings2[1]).GetInt();
                        }
                        break;
                    case 1:
                        {
                            _car_deactive_buff_id = a8::XValue(strings2[1]).GetInt();
                        }
                        break;
                    default:
                        {
                            _car_buff_list.push_back
                                (std::make_tuple
                                 (
                                  (float)a8::XValue(strings2[0]).GetDouble(),
                                  a8::XValue(strings2[1]).GetInt())
                                 );
                        }
                        break;
                    }
                } else {
                    A8_ABORT();
                }
                ++j;
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(special_damage_type(), strings, '|');
            for (auto& str : strings) {
                int n = a8::XValue(str);
                if (n <= 0 || n > 63) {
                    A8_ABORT();
                }
                a8::SetBitFlag(_special_damage_type, n);
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(hit_buff(), strings, '|');
            for (auto& str : strings) {
                _hit_buff_list.push_back(a8::XValue(str));
            }
        }
        {
            _heal = std::make_tuple<int, float>(0, 0.0f);
            std::vector<std::string> strings;
            a8::Split(heal(), strings, ':');
            if (strings.size() > 1) {
                _heal = std::make_tuple<int, float>(a8::XValue(strings[0]).GetInt(),
                                                    a8::XValue(strings[1]).GetDouble());
            }
        }
    }

    void Equip::Init2()
    {
        if (equip_type() == EQUIP_TYPE_WEAPON) {
            const mt::Equip* bullet = mt::Equip::GetById(use_bullet());
            if (!bullet) {
                #if 0
                a8::XPrintf("no bullet %d\n", {i->id()});
                #else
                A8_ABORT();
                #endif
            }
        }
        if (inventory_slot().empty()) {
            _inventory_slot_ = -1;
        } else {
            _inventory_slot_ = a8::XValue(inventory_slot());
        }
        if (_inventory_slot() > -1) {
            slot_hash_[_inventory_slot()] = this;
        }
    }

    int Equip::GetWeaponIdx() const
    {
        int weapon_idx = -1;
        if (equip_type() == EQUIP_TYPE_WEAPON) {
            if (equip_subtype() == 1) {
                return 0;
            } else {
                return GUN_SLOT1;
            }
        }
        return weapon_idx;
    }

    bool Equip::Match(EventAddBuff_e event, int val, int val2) const
    {
        switch (event) {
        case kEventBuffUpdateWeaponId:
        case kEventBuffShotWeaponId:
            {
                return val == id();
            }
            break;
        case kEventBuffUpdateWeaponSlot:
        case kEventBuffShotWeaponSlot:
            {
                return val == _inventory_slot();
            }
            break;
        case kEventBuffUpdateWeaponType:
        case kEventBuffShotWeaponType:
            {
                return val == equip_subtype() &&
                    (val2 == 0 || val2 == equip_type());
            }
            break;
        default:
            {
                return false;
            }
            break;
        }
    }

    const Equip* Equip::GetByIdBySlotId(int slot_id)
    {
        auto itr = slot_hash_.find(slot_id);
        return itr != slot_hash_.end() ? itr->second : nullptr;
    }

    void Equip::AddMuzzlePos(int lv, std::shared_ptr<std::tuple<float, float, float>> pos)
    {
        _gun_muzzle_position_hash_[lv] = pos;
    }

    void Equip::AdjustMuzzlePos()
    {
        Equip::MutTraverse
            (
             []
             (mt::Equip* meta, bool& stop) mutable
             {
                 if (meta->_gun_muzzle_position_hash_.size() == 1) {
                     if (meta->_gun_muzzle_position_hash_.find(0) !=
                         meta->_gun_muzzle_position_hash_.end()) {
                         for (int i = 0; i < MAX_WEAPON_LV; ++i) {
                             meta->_gun_muzzle_positions.push_back(meta->_gun_muzzle_position_hash_[0]);
                         }
                     } else if (meta->_gun_muzzle_position_hash_.find(1) !=
                                meta->_gun_muzzle_position_hash_.end()) {
                         for (int i = 0; i < MAX_WEAPON_LV; ++i) {
                             meta->_gun_muzzle_positions.push_back(meta->_gun_muzzle_position_hash_[1]);
                         }
                     } else {
                         abort();
                     }
                 } else if (meta->_gun_muzzle_position_hash_.size() > 1) {
                     if (meta->_gun_muzzle_position_hash_.find(1) ==
                         meta->_gun_muzzle_position_hash_.end()) {
                         abort();
                     }
                     for (int i = 0; i < MAX_WEAPON_LV; ++i) {
                         auto itr = meta->_gun_muzzle_position_hash_.find(i + 1);
                         if (itr != meta->_gun_muzzle_position_hash_.end()){
                             meta->_gun_muzzle_positions.push_back(itr->second);
                         } else {
                             meta->_gun_muzzle_positions.push_back
                                 (
                                  meta->_gun_muzzle_positions.at(meta->_gun_muzzle_positions.size() - 1)
                                  );
                         }
                     }
                 }
             });
    }

    void Equip::StaticPostInit()
    {
        yellow_stone_ = GetById(YELLOW_STONE_ID);
        blue_stone_ = GetById(BLUE_STONE_ID);
        purple_stone_ = GetById(PURPLE_STONE_ID);
        weapon_stone_ = GetById(WEAPON_STONE_ID);
    }

    const Equip* Equip::GetYellowStone()
    {
        return yellow_stone_;
    }

    const Equip* Equip::GetBlueStone()
    {
        return blue_stone_;
    }

    const Equip* Equip::GetPurpleStone()
    {
        return purple_stone_;
    }

    const Equip* Equip::GetWeaponStone()
    {
        return weapon_stone_;
    }

    bool Equip::IsMultistageGun() const
    {
        return id() == 20911;
    }

}
