#include "precompile.h"

#include "mt/MapThing.h"

IMPL_TABLE(mt::MapThing)

namespace mt
{

    void MapThing::Init1()
    {
        {
            std::vector<std::string> strings;
            a8::Split(buff_list(), strings, '|');
            for (const std::string& tmp_str : strings) {
                _buff_list.push_back(a8::XValue(tmp_str));
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(preexplosion_summon(), strings, '|');
            for (const std::string& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                assert(strings2.size() == 2);
                _preexplosion_summon.push_back
                    (std::make_tuple(
                                     a8::XValue(strings2[0]),
                                     a8::XValue(strings2[1])
                                     )
                     );
            }
        }
        {
            int total_weight = 0;
            std::vector<std::string> strings;
            a8::Split(drop(), strings, '|');
            for (const std::string& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                int drop_id = a8::XValue(strings2[0]);
                int weight = strings2.size() > 1 ? a8::XValue(strings2[1]).GetInt() : -1;
                total_weight += weight;
                _drop.push_back
                    (std::make_tuple(
                                     drop_id,
                                     total_weight
                                     )
                     );
            }
            total_weight = std::max(total_weight, 1);
        }
        {
            std::vector<std::string> strings;
            a8::Split(monster_list(), strings, '|');
            for (const std::string& tmp_str : strings) {
                _airdrop_mon_list.push_back(a8::XValue(tmp_str));
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(special_damage_type(), strings, '|');
            for (auto& str : strings) {
                int n = a8::XValue(str);
                if (n <= 0 || n > 63) {
                    A8_ABORT();
                }
                a8::SetBitFlag(_special_damage_type, n);
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(receive_special_damage_type(), strings, '|');
            for (auto& str : strings) {
                int n = a8::XValue(str);
                if (n <= 0 || n > 63) {
                    A8_ABORT();
                }
                a8::SetBitFlag(_receive_special_damage_type, n);
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(sweep_tags(), strings, '|');
            for (auto& str : strings) {
                int n = a8::XValue(str);
                if (n <= 0 || n > 63) {
                    A8_ABORT();
                }
                a8::SetBitFlag(_sweep_tags, n);
            }
        }
        {
            _int_param1 = a8::XValue(param1());
            _float_param1 = a8::XValue(param1()).GetDouble();
        }
        {
            _int_param2 = a8::XValue(param2());
            _float_param2 = a8::XValue(param2()).GetDouble();
        }
        {
            std::vector<std::string> strings;
            a8::Split(param2(), strings, '|');
            for (auto& str : strings) {
                _param2_list.push_back(a8::XValue(str));
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(shapes(), strings, '|');
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                _shapes.push_back(std::make_tuple
                                 (
                                  a8::XValue(strings2[0]).GetInt(),
                                  a8::XValue(strings2[1]).GetInt(),
                                  a8::XValue(strings2[2]).GetInt()
                                  ));
            }
        }
    }

    std::vector<int> MapThing::RandDrop() const
    {
        std::vector<int> drops;
        if (HasDrop()) {
            int total_weight = std::get<1>(_drop[_drop.size() - 1]);
            int rnd = rand() % total_weight;
            for (auto& tuple : _drop) {
                if (std::get<1>(tuple) < 0){
                        drops.push_back(std::get<0>(tuple));
                } else {
                    if (rnd < std::get<1>(tuple)) {
                        drops.push_back(std::get<0>(tuple));
                    }
                }
            }
        }
        return drops;
    }

}
