#pragma once

#include "mt/macro.h"
#include "mtb/Skill.h"

namespace mt
{

    struct SkillPhase
    {
        int phase_idx = 0;
        int time_offset = 0;
        SkillFunc_e func_id = kSkill_FuncNone;
        a8::XValue phase_param1;
        a8::XValue phase_param2;
        a8::XValue phase_param3;

        std::string phase_param1_str;
        std::string phase_param2_str;
        std::string phase_param3_str;

        std::vector<int> phase_param1_ints;
        std::vector<int> phase_param2_ints;
        std::vector<int> phase_param3_ints;
    };

    DECLARE_ID_TABLE(Skill, mtb::Skill,
                     "skill@skill.json",
                     "skill_id")
    public:

       struct mt::SkillNumber* _number_meta = nullptr;

        void Init1();
        void Init2();

        const mt::Skill* _base_skill_meta = nullptr;
        float _value_up = 0.0f;
        std::set<int> _buff_list;
        std::map<int, std::vector<const mt::Buff*>> _trigger_type_buffs;
        std::vector<mt::SkillPhase> _phases;
        std::vector<mt::SkillPhase> _raw_phases;
        bool IsTurnOverSkill() const;
        int GetMagicId() const;

        void SetSkillDistance(float distance) const;
    private:
        int _magic_id = 0;
        int _base_skill_id = 0;

    };

}
