#pragma once

#include <bitset>

namespace mtb
{

  class BattleHeroGrow
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int invoke() const { return invoke_; };
    int heroId() const { return heroId_; };
    int level() const { return level_; };
    int levelExp() const { return levelExp_; };
    int cumExp() const { return cumExp_; };
    int lootExp() const { return lootExp_; };
    const std::string currentLevelAttribute() const { return currentLevelAttribute_; };
    const std::string currentEquipEffect() const { return currentEquipEffect_; };
    int currentSkillEffect() const { return currentSkillEffect_; };
    const std::string currentSkillDesc() const { return currentSkillDesc_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_invoke() const { return __flags__.test(1);};
    bool has_heroId() const { return __flags__.test(2);};
    bool has_level() const { return __flags__.test(3);};
    bool has_levelExp() const { return __flags__.test(4);};
    bool has_cumExp() const { return __flags__.test(5);};
    bool has_lootExp() const { return __flags__.test(6);};
    bool has_currentLevelAttribute() const { return __flags__.test(7);};
    bool has_currentEquipEffect() const { return __flags__.test(8);};
    bool has_currentSkillEffect() const { return __flags__.test(9);};
    bool has_currentSkillDesc() const { return __flags__.test(10);};

  protected:

    int id_ = 0;
    int invoke_ = 0;
    int heroId_ = 0;
    int level_ = 0;
    int levelExp_ = 0;
    int cumExp_ = 0;
    int lootExp_ = 0;
    std::string currentLevelAttribute_;
    std::string currentEquipEffect_;
    int currentSkillEffect_ = 0;
    std::string currentSkillDesc_;

public:
    std::bitset<11> __flags__;
  };

};
