#pragma once

#include <bitset>

namespace mtb
{

  class InGameVoice
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int event_type() const { return event_type_; };
    int sound_id() const { return sound_id_; };
    const std::string cond() const { return cond_; };
    const std::string notify_object() const { return notify_object_; };
    int notify_fields() const { return notify_fields_; };
    int play_interval() const { return play_interval_; };
    int series_kill_interval() const { return series_kill_interval_; };
    int play_scene() const { return play_scene_; };
    int id() const { return id_; };

    bool has_event_type() const { return __flags__.test(0);};
    bool has_sound_id() const { return __flags__.test(1);};
    bool has_cond() const { return __flags__.test(2);};
    bool has_notify_object() const { return __flags__.test(3);};
    bool has_notify_fields() const { return __flags__.test(4);};
    bool has_play_interval() const { return __flags__.test(5);};
    bool has_series_kill_interval() const { return __flags__.test(6);};
    bool has_play_scene() const { return __flags__.test(7);};
    bool has_id() const { return __flags__.test(8);};

  protected:

    int event_type_ = 0;
    int sound_id_ = 0;
    std::string cond_;
    std::string notify_object_;
    int notify_fields_ = 0;
    int play_interval_ = 0;
    int series_kill_interval_ = 0;
    int play_scene_ = 0;
    int id_ = 0;

public:
    std::bitset<9> __flags__;
  };

};
