#pragma once

#include <bitset>

namespace mtb
{

  class Map
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int map_id() const { return map_id_; };
    const std::string template_list() const { return template_list_; };
    const std::string map_name() const { return map_name_; };
    float map_width() const { return map_width_; };
    float map_height() const { return map_height_; };
    const std::string airdrops() const { return airdrops_; };
    int terminator_airdrop() const { return terminator_airdrop_; };
    int player() const { return player_; };
    const std::string refresh_robot() const { return refresh_robot_; };
    int map_mode() const { return map_mode_; };
    const std::string safearea() const { return safearea_; };
    const std::string game_start_buff_list() const { return game_start_buff_list_; };
    const std::string map_pic() const { return map_pic_; };
    const std::string first_safearea_center() const { return first_safearea_center_; };
    int init_gas_ring() const { return init_gas_ring_; };
    const std::string airraids() const { return airraids_; };
    const std::string car_num_limit() const { return car_num_limit_; };
    float scale() const { return scale_; };
    const std::string map_collider() const { return map_collider_; };
    const std::string world_object_file() const { return world_object_file_; };
    const std::string terrain_file() const { return terrain_file_; };
    int map_type() const { return map_type_; };
    int team() const { return team_; };
    int star_condition() const { return star_condition_; };
    int is_open() const { return is_open_; };
    const std::string ground_sampling_pos() const { return ground_sampling_pos_; };
    const std::string navmesh_file() const { return navmesh_file_; };
    int moba_time() const { return moba_time_; };
    int is_moba() const { return is_moba_; };
    int support_sandtable() const { return support_sandtable_; };

    bool has_map_id() const { return __flags__.test(0);};
    bool has_template_list() const { return __flags__.test(1);};
    bool has_map_name() const { return __flags__.test(2);};
    bool has_map_width() const { return __flags__.test(3);};
    bool has_map_height() const { return __flags__.test(4);};
    bool has_airdrops() const { return __flags__.test(5);};
    bool has_terminator_airdrop() const { return __flags__.test(6);};
    bool has_player() const { return __flags__.test(7);};
    bool has_refresh_robot() const { return __flags__.test(8);};
    bool has_map_mode() const { return __flags__.test(9);};
    bool has_safearea() const { return __flags__.test(10);};
    bool has_game_start_buff_list() const { return __flags__.test(11);};
    bool has_map_pic() const { return __flags__.test(12);};
    bool has_first_safearea_center() const { return __flags__.test(13);};
    bool has_init_gas_ring() const { return __flags__.test(14);};
    bool has_airraids() const { return __flags__.test(15);};
    bool has_car_num_limit() const { return __flags__.test(16);};
    bool has_scale() const { return __flags__.test(17);};
    bool has_map_collider() const { return __flags__.test(18);};
    bool has_world_object_file() const { return __flags__.test(19);};
    bool has_terrain_file() const { return __flags__.test(20);};
    bool has_map_type() const { return __flags__.test(21);};
    bool has_team() const { return __flags__.test(22);};
    bool has_star_condition() const { return __flags__.test(23);};
    bool has_is_open() const { return __flags__.test(24);};
    bool has_ground_sampling_pos() const { return __flags__.test(25);};
    bool has_navmesh_file() const { return __flags__.test(26);};
    bool has_moba_time() const { return __flags__.test(27);};
    bool has_is_moba() const { return __flags__.test(28);};
    bool has_support_sandtable() const { return __flags__.test(29);};

  protected:

    int map_id_ = 0;
    std::string template_list_;
    std::string map_name_;
    float map_width_ = 0.0f;
    float map_height_ = 0.0f;
    std::string airdrops_;
    int terminator_airdrop_ = 0;
    int player_ = 0;
    std::string refresh_robot_;
    int map_mode_ = 0;
    std::string safearea_;
    std::string game_start_buff_list_;
    std::string map_pic_;
    std::string first_safearea_center_;
    int init_gas_ring_ = 0;
    std::string airraids_;
    std::string car_num_limit_;
    float scale_ = 0.0f;
    std::string map_collider_;
    std::string world_object_file_;
    std::string terrain_file_;
    int map_type_ = 0;
    int team_ = 0;
    int star_condition_ = 0;
    int is_open_ = 0;
    std::string ground_sampling_pos_;
    std::string navmesh_file_;
    int moba_time_ = 0;
    int is_moba_ = 0;
    int support_sandtable_ = 0;

public:
    std::bitset<30> __flags__;
  };

};
