#pragma once

#include <bitset>

namespace mtb
{

  class MapThing
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int thing_id() const { return thing_id_; };
    int thing_type() const { return thing_type_; };
    int time() const { return time_; };
    int type() const { return type_; };
    int height() const { return height_; };
    int width() const { return width_; };
    int hp() const { return hp_; };
    float damage() const { return damage_; };
    float damage_dia() const { return damage_dia_; };
    const std::string drop() const { return drop_; };
    int is_door() const { return is_door_; };
    int is_house() const { return is_house_; };
    int is_tree() const { return is_tree_; };
    int house_id() const { return house_id_; };
    const std::string buff_list() const { return buff_list_; };
    int explosion_effect() const { return explosion_effect_; };
    int explosion_interval() const { return explosion_interval_; };
    int explosion_dmg_delay() const { return explosion_dmg_delay_; };
    int explosion_times() const { return explosion_times_; };
    int explosion_float() const { return explosion_float_; };
    const std::string preexplosion_summon() const { return preexplosion_summon_; };
    const std::string monster_list() const { return monster_list_; };
    const std::string special_damage_type() const { return special_damage_type_; };
    const std::string receive_special_damage_type() const { return receive_special_damage_type_; };
    const std::string param1() const { return param1_; };
    const std::string param2() const { return param2_; };
    int interaction_mode() const { return interaction_mode_; };
    int view_mode() const { return view_mode_; };
    int bullet_hit() const { return bullet_hit_; };
    int collision_hit() const { return collision_hit_; };
    int explosion_hit() const { return explosion_hit_; };
    const std::string sweep_tags() const { return sweep_tags_; };
    int prebattle_hide() const { return prebattle_hide_; };
    int life_time() const { return life_time_; };
    int summon_born_rad() const { return summon_born_rad_; };
    const std::string shapes() const { return shapes_; };
    int delay_destroy() const { return delay_destroy_; };

    bool has_thing_id() const { return __flags__.test(0);};
    bool has_thing_type() const { return __flags__.test(1);};
    bool has_time() const { return __flags__.test(2);};
    bool has_type() const { return __flags__.test(3);};
    bool has_height() const { return __flags__.test(4);};
    bool has_width() const { return __flags__.test(5);};
    bool has_hp() const { return __flags__.test(6);};
    bool has_damage() const { return __flags__.test(7);};
    bool has_damage_dia() const { return __flags__.test(8);};
    bool has_drop() const { return __flags__.test(9);};
    bool has_is_door() const { return __flags__.test(10);};
    bool has_is_house() const { return __flags__.test(11);};
    bool has_is_tree() const { return __flags__.test(12);};
    bool has_house_id() const { return __flags__.test(13);};
    bool has_buff_list() const { return __flags__.test(14);};
    bool has_explosion_effect() const { return __flags__.test(15);};
    bool has_explosion_interval() const { return __flags__.test(16);};
    bool has_explosion_dmg_delay() const { return __flags__.test(17);};
    bool has_explosion_times() const { return __flags__.test(18);};
    bool has_explosion_float() const { return __flags__.test(19);};
    bool has_preexplosion_summon() const { return __flags__.test(20);};
    bool has_monster_list() const { return __flags__.test(21);};
    bool has_special_damage_type() const { return __flags__.test(22);};
    bool has_receive_special_damage_type() const { return __flags__.test(23);};
    bool has_param1() const { return __flags__.test(24);};
    bool has_param2() const { return __flags__.test(25);};
    bool has_interaction_mode() const { return __flags__.test(26);};
    bool has_view_mode() const { return __flags__.test(27);};
    bool has_bullet_hit() const { return __flags__.test(28);};
    bool has_collision_hit() const { return __flags__.test(29);};
    bool has_explosion_hit() const { return __flags__.test(30);};
    bool has_sweep_tags() const { return __flags__.test(31);};
    bool has_prebattle_hide() const { return __flags__.test(32);};
    bool has_life_time() const { return __flags__.test(33);};
    bool has_summon_born_rad() const { return __flags__.test(34);};
    bool has_shapes() const { return __flags__.test(35);};
    bool has_delay_destroy() const { return __flags__.test(36);};

  protected:

    int thing_id_ = 0;
    int thing_type_ = 0;
    int time_ = 0;
    int type_ = 0;
    int height_ = 0;
    int width_ = 0;
    int hp_ = 0;
    float damage_ = 0.0f;
    float damage_dia_ = 0.0f;
    std::string drop_;
    int is_door_ = 0;
    int is_house_ = 0;
    int is_tree_ = 0;
    int house_id_ = 0;
    std::string buff_list_;
    int explosion_effect_ = 0;
    int explosion_interval_ = 0;
    int explosion_dmg_delay_ = 0;
    int explosion_times_ = 0;
    int explosion_float_ = 0;
    std::string preexplosion_summon_;
    std::string monster_list_;
    std::string special_damage_type_;
    std::string receive_special_damage_type_;
    std::string param1_;
    std::string param2_;
    int interaction_mode_ = 0;
    int view_mode_ = 0;
    int bullet_hit_ = 0;
    int collision_hit_ = 0;
    int explosion_hit_ = 0;
    std::string sweep_tags_;
    int prebattle_hide_ = 0;
    int life_time_ = 0;
    int summon_born_rad_ = 0;
    std::string shapes_;
    int delay_destroy_ = 0;

public:
    std::bitset<37> __flags__;
  };

};
