#pragma once

#include <bitset>

namespace mtb
{

  class MobaRoom
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int map_id() const { return map_id_; };
    int revive_time() const { return revive_time_; };
    int game_time() const { return game_time_; };
    int tower_interval() const { return tower_interval_; };
    float tower_recover_hp_rate() const { return tower_recover_hp_rate_; };
    const std::string towers() const { return towers_; };
    const std::string monster_revive() const { return monster_revive_; };
    const std::string batterys() const { return batterys_; };

    bool has_map_id() const { return __flags__.test(0);};
    bool has_revive_time() const { return __flags__.test(1);};
    bool has_game_time() const { return __flags__.test(2);};
    bool has_tower_interval() const { return __flags__.test(3);};
    bool has_tower_recover_hp_rate() const { return __flags__.test(4);};
    bool has_towers() const { return __flags__.test(5);};
    bool has_monster_revive() const { return __flags__.test(6);};
    bool has_batterys() const { return __flags__.test(7);};

  protected:

    int map_id_ = 0;
    int revive_time_ = 0;
    int game_time_ = 0;
    int tower_interval_ = 0;
    float tower_recover_hp_rate_ = 0.0f;
    std::string towers_;
    std::string monster_revive_;
    std::string batterys_;

public:
    std::bitset<8> __flags__;
  };

};
