#pragma once

#include <bitset>

namespace mtb
{

  class RankPoint
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int rank() const { return rank_; };
    int parameter() const { return parameter_; };
    int parameter2() const { return parameter2_; };
    int parameter3() const { return parameter3_; };

    bool has_rank() const { return __flags__.test(0);};
    bool has_parameter() const { return __flags__.test(1);};
    bool has_parameter2() const { return __flags__.test(2);};
    bool has_parameter3() const { return __flags__.test(3);};

  protected:

    int rank_ = 0;
    int parameter_ = 0;
    int parameter2_ = 0;
    int parameter3_ = 0;

public:
    std::bitset<4> __flags__;
  };

};
