#pragma once

#include <bitset>

namespace mtb
{

  class RankRoom
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int elo_min() const { return elo_min_; };
    int elo_max() const { return elo_max_; };
    int elo_expansion1() const { return elo_expansion1_; };
    int elo_expansion2() const { return elo_expansion2_; };
    int expand_time1() const { return expand_time1_; };
    int expand_time2() const { return expand_time2_; };
    int player_num_standard() const { return player_num_standard_; };
    int final_time() const { return final_time_; };
    int final_player_num() const { return final_player_num_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_elo_min() const { return __flags__.test(1);};
    bool has_elo_max() const { return __flags__.test(2);};
    bool has_elo_expansion1() const { return __flags__.test(3);};
    bool has_elo_expansion2() const { return __flags__.test(4);};
    bool has_expand_time1() const { return __flags__.test(5);};
    bool has_expand_time2() const { return __flags__.test(6);};
    bool has_player_num_standard() const { return __flags__.test(7);};
    bool has_final_time() const { return __flags__.test(8);};
    bool has_final_player_num() const { return __flags__.test(9);};

  protected:

    int id_ = 0;
    int elo_min_ = 0;
    int elo_max_ = 0;
    int elo_expansion1_ = 0;
    int elo_expansion2_ = 0;
    int expand_time1_ = 0;
    int expand_time2_ = 0;
    int player_num_standard_ = 0;
    int final_time_ = 0;
    int final_player_num_ = 0;

public:
    std::bitset<10> __flags__;
  };

};
