#pragma once

#include <bitset>

namespace mtb
{

  class Robot
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    const std::string name() const { return name_; };
    int hero_id() const { return hero_id_; };
    const std::string skin_id() const { return skin_id_; };
    int weapon_id() const { return weapon_id_; };
    int weapon_lv() const { return weapon_lv_; };
    int sex() const { return sex_; };
    float dmg_ratio() const { return dmg_ratio_; };
    const std::string bullet_offset() const { return bullet_offset_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_name() const { return __flags__.test(1);};
    bool has_hero_id() const { return __flags__.test(2);};
    bool has_skin_id() const { return __flags__.test(3);};
    bool has_weapon_id() const { return __flags__.test(4);};
    bool has_weapon_lv() const { return __flags__.test(5);};
    bool has_sex() const { return __flags__.test(6);};
    bool has_dmg_ratio() const { return __flags__.test(7);};
    bool has_bullet_offset() const { return __flags__.test(8);};

  protected:

    int id_ = 0;
    std::string name_;
    int hero_id_ = 0;
    std::string skin_id_;
    int weapon_id_ = 0;
    int weapon_lv_ = 0;
    int sex_ = 0;
    float dmg_ratio_ = 0.0f;
    std::string bullet_offset_;

public:
    std::bitset<9> __flags__;
  };

};
