#pragma once

#include <bitset>

namespace mtb
{

  class Skill
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int skill_id() const { return skill_id_; };
    int skill_type() const { return skill_type_; };
    const std::string value_up() const { return value_up_; };
    int skill_cd() const { return skill_cd_; };
    int skill_target() const { return skill_target_; };
    const std::string buff_list() const { return buff_list_; };
    float skill_distance() const { return skill_distance_; };
    int cold_time_up() const { return cold_time_up_; };
    int max_times() const { return max_times_; };
    int phase1_time_offset() const { return phase1_time_offset_; };
    int phase1_func() const { return phase1_func_; };
    const std::string phase1_param1() const { return phase1_param1_; };
    const std::string phase1_param2() const { return phase1_param2_; };
    const std::string phase1_param3() const { return phase1_param3_; };
    int phase2_time_offset() const { return phase2_time_offset_; };
    int phase2_func() const { return phase2_func_; };
    const std::string phase2_param1() const { return phase2_param1_; };
    const std::string phase2_param2() const { return phase2_param2_; };
    const std::string phase2_param3() const { return phase2_param3_; };
    int phase3_time_offset() const { return phase3_time_offset_; };
    int phase3_func() const { return phase3_func_; };
    const std::string phase3_param1() const { return phase3_param1_; };
    const std::string phase3_param2() const { return phase3_param2_; };
    const std::string phase3_param3() const { return phase3_param3_; };
    int cast_time() const { return cast_time_; };
    int up_exp() const { return up_exp_; };
    int nextlv_skill() const { return nextlv_skill_; };
    int attack_dir_lock_time() const { return attack_dir_lock_time_; };
    int skill_hold_buff() const { return skill_hold_buff_; };

    bool has_skill_id() const { return __flags__.test(0);};
    bool has_skill_type() const { return __flags__.test(1);};
    bool has_value_up() const { return __flags__.test(2);};
    bool has_skill_cd() const { return __flags__.test(3);};
    bool has_skill_target() const { return __flags__.test(4);};
    bool has_buff_list() const { return __flags__.test(5);};
    bool has_skill_distance() const { return __flags__.test(6);};
    bool has_cold_time_up() const { return __flags__.test(7);};
    bool has_max_times() const { return __flags__.test(8);};
    bool has_phase1_time_offset() const { return __flags__.test(9);};
    bool has_phase1_func() const { return __flags__.test(10);};
    bool has_phase1_param1() const { return __flags__.test(11);};
    bool has_phase1_param2() const { return __flags__.test(12);};
    bool has_phase1_param3() const { return __flags__.test(13);};
    bool has_phase2_time_offset() const { return __flags__.test(14);};
    bool has_phase2_func() const { return __flags__.test(15);};
    bool has_phase2_param1() const { return __flags__.test(16);};
    bool has_phase2_param2() const { return __flags__.test(17);};
    bool has_phase2_param3() const { return __flags__.test(18);};
    bool has_phase3_time_offset() const { return __flags__.test(19);};
    bool has_phase3_func() const { return __flags__.test(20);};
    bool has_phase3_param1() const { return __flags__.test(21);};
    bool has_phase3_param2() const { return __flags__.test(22);};
    bool has_phase3_param3() const { return __flags__.test(23);};
    bool has_cast_time() const { return __flags__.test(24);};
    bool has_up_exp() const { return __flags__.test(25);};
    bool has_nextlv_skill() const { return __flags__.test(26);};
    bool has_attack_dir_lock_time() const { return __flags__.test(27);};
    bool has_skill_hold_buff() const { return __flags__.test(28);};

  protected:

    int skill_id_ = 0;
    int skill_type_ = 0;
    std::string value_up_;
    int skill_cd_ = 0;
    int skill_target_ = 0;
    std::string buff_list_;
    float skill_distance_ = 0.0f;
    int cold_time_up_ = 0;
    int max_times_ = 0;
    int phase1_time_offset_ = 0;
    int phase1_func_ = 0;
    std::string phase1_param1_;
    std::string phase1_param2_;
    std::string phase1_param3_;
    int phase2_time_offset_ = 0;
    int phase2_func_ = 0;
    std::string phase2_param1_;
    std::string phase2_param2_;
    std::string phase2_param3_;
    int phase3_time_offset_ = 0;
    int phase3_func_ = 0;
    std::string phase3_param1_;
    std::string phase3_param2_;
    std::string phase3_param3_;
    int cast_time_ = 0;
    int up_exp_ = 0;
    int nextlv_skill_ = 0;
    int attack_dir_lock_time_ = 0;
    int skill_hold_buff_ = 0;

public:
    std::bitset<29> __flags__;
  };

};
