#pragma once

class Room;
class Player;

class RoomOb : public std::enable_shared_from_this<RoomOb>
{
 public:

    RoomOb(Room* room);
    ~RoomOb();
    void Init();
    void UnInit();

    Player* GetByAccountId(const std::string& account_id);
    void AddOb(Player* hum);
    void TraverseOb(std::function<bool (Player*)> cb);
    bool HasOb() { return !id_hash_.empty(); }

private:
    Room* room_ = nullptr;
    std::map<std::string, Player*> id_hash_;
};
