#pragma once

namespace cs
{
    class MFSkill;
}

enum SkillMinorType
{
   SMT_NONE = 0,
   SMT_BLINK = 1,
   SMT_DISABLE = 2,
};

enum SkillMinorAction
{
   kSmaTimeOut = 0,
   kSmaClick = 1,
   kSmaCancel = 2,
};

class Creature;
class Skill
{
 public:
    Creature* owner = nullptr;
    long long last_use_frameno = 0;
    long long last_sync_frameno = 0;
    a8::Attacher xtimer_attacher;
    int force_use_times = 0;
    glm::vec3 skill_pos = glm::vec3(0.0f, 0.0f, 0.0f);

    void Initialzie();
    void SetMeta(const mt::Skill* meta);
    const mt::Skill* GetBaseSkillMeta() { return meta_; };
    int GetCd();
    int GetLeftTime();
    int GetPassedTime();
    int GetCurrTimes();
    int GetMaxTimes();
    int GetCurrExp();
    void SetCurrExp(int exp);
    int GetMaxExp();
    void DecTimes();
    void FillMFSkill(cs::MFSkill* skill_pb);
    void ResetSkillCd();
    void Accelerate(int time);
    void LockCastPhase();
    int GetMinorType() { return minor_type_; }
    void AddMinorMode(
                      int minor_type,
                      int minor_cd_time,
                      std::function<void(int)> cb,
                      int buff_id
                      );
    void DoMinorMode();
    void CancelMinorMode();
    void ProcSkillPhase(const mt::SkillPhase* phase);
    bool Actived() { return actived_; }
    void Active();
    void Deactive() { actived_ = false; }
    bool IsMainSkill();
    void LevelUp();
    bool IsFullLevel();
    void Clear();
    const mt::Skill* GetCurrSkillMeta();
    int GetSkillId();
    int GetBaseSkillId();
    bool IsPassiveSkill();

private:
    void InitActiveSkill();
    void InitPassiveSkill();

    void NotifySkillState();

    void Proc30701BAO();

    void ProcShotPhase(const mt::SkillPhase* phase);
    void ProcSpecDirShotPhase(const mt::SkillPhase* phase);
    void ProcJumpToPhase(const mt::SkillPhase* phase);
    void ProcNormalShotPhase(const mt::SkillPhase* phase);

private:
    const mt::Skill* meta_ = nullptr;
    const mt::Skill* curr_meta_ = nullptr;
    bool actived_ = false;
    int level_ = 1;
    int curr_times_ = 0;
    a8::XTimerWp inc_times_timer_;
    a8::XTimerWp minor_mode_timer_;
    int curr_exp_ = 0;
    int minor_type_ = 0;
    int minor_cd_time_ = 0;
    long long minor_frameno_ = 0;
    std::function<void(int)> minor_cb_;
    std::vector<int> hold_buffs_;

    friend class PBUtils;
};
