#include "precompile.h"

#include "perf.h"

#include <f8/timer.h>
#include <f8/udplog.h>

void Perf::Init()
{
    f8::Timer::Instance()->SetInterval
        (1000 * 3,
         [this] (int event, const a8::Args* args)
         {
             if (a8::TIMER_EXEC_EVENT == event) {
                 Output();
             }
         });
}

void Perf::UnInit()
{

}

void Perf::Output()
{
    f8::UdpLog::Instance()->Info
        ("perf login_ok:%d login_fail:%d enter_ok:%d enter_fail:%d connect_ok:%d connect_fail:%d join_ok:%d chg_dir:%d send_move:%d update:%d",
         {
          login_ok_times,
          login_fail_times,
          enter_ok_times,
          enter_fail_times,
          connect_ok_times,
          connect_fail_times,
          join_ok_times,
          chg_dir_times,
          send_move_times,
          update_times
         });
}
